diff --git a/src/backend/catalog/pg_constraint.c b/src/backend/catalog/pg_constraint.c
index b5a0ce9..6757d9c 100644
--- a/src/backend/catalog/pg_constraint.c
+++ b/src/backend/catalog/pg_constraint.c
@@ -229,7 +229,7 @@ CreateConstraintEntry(const char *constraintName,
 	conOid = simple_heap_insert(conDesc, tup);
 
 	/* update catalog indexes */
-	CatalogUpdateIndexes(conDesc, tup);
+	CatalogUpdateIndexes(conDesc, tup, false, NULL);
 
 	conobject.classId = ConstraintRelationId;
 	conobject.objectId = conOid;
@@ -570,6 +570,8 @@ RemoveConstraintById(Oid conId)
 			Relation	pgrel;
 			HeapTuple	relTup;
 			Form_pg_class classForm;
+			bool		warm_update;
+			Bitmapset	*modified_attrs;
 
 			pgrel = heap_open(RelationRelationId, RowExclusiveLock);
 			relTup = SearchSysCacheCopy1(RELOID,
@@ -584,9 +586,10 @@ RemoveConstraintById(Oid conId)
 					 RelationGetRelationName(rel));
 			classForm->relchecks--;
 
-			simple_heap_update(pgrel, &relTup->t_self, relTup);
+			simple_heap_update(pgrel, &relTup->t_self, relTup, &warm_update,
+					&modified_attrs);
 
-			CatalogUpdateIndexes(pgrel, relTup);
+			CatalogUpdateIndexes(pgrel, relTup, warm_update, modified_attrs);
 
 			heap_freetuple(relTup);
 
@@ -632,6 +635,8 @@ RenameConstraintById(Oid conId, const char *newname)
 	Relation	conDesc;
 	HeapTuple	tuple;
 	Form_pg_constraint con;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	conDesc = heap_open(ConstraintRelationId, RowExclusiveLock);
 
@@ -666,10 +671,11 @@ RenameConstraintById(Oid conId, const char *newname)
 	/* OK, do the rename --- tuple is a copy, so OK to scribble on it */
 	namestrcpy(&(con->conname), newname);
 
-	simple_heap_update(conDesc, &tuple->t_self, tuple);
+	simple_heap_update(conDesc, &tuple->t_self, tuple, &warm_update,
+			&modified_attrs);
 
 	/* update the system catalog indexes */
-	CatalogUpdateIndexes(conDesc, tuple);
+	CatalogUpdateIndexes(conDesc, tuple, warm_update, modified_attrs);
 
 	InvokeObjectPostAlterHook(ConstraintRelationId, conId, 0);
 
@@ -731,13 +737,17 @@ AlterConstraintNamespaces(Oid ownerId, Oid oldNspId,
 		/* Don't update if the object is already part of the namespace */
 		if (conform->connamespace == oldNspId && oldNspId != newNspId)
 		{
+			bool	warm_update;
+			Bitmapset	*modified_attrs;
+
 			tup = heap_copytuple(tup);
 			conform = (Form_pg_constraint) GETSTRUCT(tup);
 
 			conform->connamespace = newNspId;
 
-			simple_heap_update(conRel, &tup->t_self, tup);
-			CatalogUpdateIndexes(conRel, tup);
+			simple_heap_update(conRel, &tup->t_self, tup, &warm_update,
+					&modified_attrs);
+			CatalogUpdateIndexes(conRel, tup, warm_update, modified_attrs);
 
 			/*
 			 * Note: currently, the constraint will not have its own
diff --git a/src/backend/catalog/pg_conversion.c b/src/backend/catalog/pg_conversion.c
index adaf7b8..99da1f3 100644
--- a/src/backend/catalog/pg_conversion.c
+++ b/src/backend/catalog/pg_conversion.c
@@ -108,7 +108,7 @@ ConversionCreate(const char *conname, Oid connamespace,
 	simple_heap_insert(rel, tup);
 
 	/* update the index if any */
-	CatalogUpdateIndexes(rel, tup);
+	CatalogUpdateIndexes(rel, tup, false, NULL);
 
 	myself.classId = ConversionRelationId;
 	myself.objectId = HeapTupleGetOid(tup);
diff --git a/src/backend/catalog/pg_db_role_setting.c b/src/backend/catalog/pg_db_role_setting.c
index 117cc8d..f592419 100644
--- a/src/backend/catalog/pg_db_role_setting.c
+++ b/src/backend/catalog/pg_db_role_setting.c
@@ -78,6 +78,8 @@ AlterSetting(Oid databaseid, Oid roleid, VariableSetStmt *setstmt)
 				bool		repl_null[Natts_pg_db_role_setting];
 				bool		repl_repl[Natts_pg_db_role_setting];
 				HeapTuple	newtuple;
+				bool		warm_update;
+				Bitmapset	*modified_attrs;
 
 				memset(repl_repl, false, sizeof(repl_repl));
 
@@ -88,10 +90,11 @@ AlterSetting(Oid databaseid, Oid roleid, VariableSetStmt *setstmt)
 
 				newtuple = heap_modify_tuple(tuple, RelationGetDescr(rel),
 											 repl_val, repl_null, repl_repl);
-				simple_heap_update(rel, &tuple->t_self, newtuple);
+				simple_heap_update(rel, &tuple->t_self, newtuple, &warm_update,
+						&modified_attrs);
 
 				/* Update indexes */
-				CatalogUpdateIndexes(rel, newtuple);
+				CatalogUpdateIndexes(rel, newtuple, warm_update, modified_attrs);
 			}
 			else
 				simple_heap_delete(rel, &tuple->t_self);
@@ -106,6 +109,8 @@ AlterSetting(Oid databaseid, Oid roleid, VariableSetStmt *setstmt)
 		Datum		datum;
 		bool		isnull;
 		ArrayType  *a;
+		bool		warm_update;
+		Bitmapset	*modified_attrs;
 
 		memset(repl_repl, false, sizeof(repl_repl));
 		repl_repl[Anum_pg_db_role_setting_setconfig - 1] = true;
@@ -129,10 +134,11 @@ AlterSetting(Oid databaseid, Oid roleid, VariableSetStmt *setstmt)
 
 			newtuple = heap_modify_tuple(tuple, RelationGetDescr(rel),
 										 repl_val, repl_null, repl_repl);
-			simple_heap_update(rel, &tuple->t_self, newtuple);
+			simple_heap_update(rel, &tuple->t_self, newtuple, &warm_update,
+					&modified_attrs);
 
 			/* Update indexes */
-			CatalogUpdateIndexes(rel, newtuple);
+			CatalogUpdateIndexes(rel, newtuple, warm_update, modified_attrs);
 		}
 		else
 			simple_heap_delete(rel, &tuple->t_self);
@@ -158,7 +164,7 @@ AlterSetting(Oid databaseid, Oid roleid, VariableSetStmt *setstmt)
 		simple_heap_insert(rel, newtuple);
 
 		/* Update indexes */
-		CatalogUpdateIndexes(rel, newtuple);
+		CatalogUpdateIndexes(rel, newtuple, false, NULL);
 	}
 
 	InvokeObjectPostAlterHookArg(DbRoleSettingRelationId,
diff --git a/src/backend/catalog/pg_depend.c b/src/backend/catalog/pg_depend.c
index b71fa1b..cae00ad 100644
--- a/src/backend/catalog/pg_depend.c
+++ b/src/backend/catalog/pg_depend.c
@@ -113,7 +113,7 @@ recordMultipleDependencies(const ObjectAddress *depender,
 			if (indstate == NULL)
 				indstate = CatalogOpenIndexes(dependDesc);
 
-			CatalogIndexInsert(indstate, tup);
+			CatalogIndexInsert(indstate, tup, false, NULL);
 
 			heap_freetuple(tup);
 		}
@@ -356,14 +356,18 @@ changeDependencyFor(Oid classId, Oid objectId,
 				simple_heap_delete(depRel, &tup->t_self);
 			else
 			{
+				bool		warm_update;
+				Bitmapset	*modified_attrs;
+
 				/* make a modifiable copy */
 				tup = heap_copytuple(tup);
 				depform = (Form_pg_depend) GETSTRUCT(tup);
 
 				depform->refobjid = newRefObjectId;
 
-				simple_heap_update(depRel, &tup->t_self, tup);
-				CatalogUpdateIndexes(depRel, tup);
+				simple_heap_update(depRel, &tup->t_self, tup, &warm_update,
+						&modified_attrs);
+				CatalogUpdateIndexes(depRel, tup, warm_update, modified_attrs);
 
 				heap_freetuple(tup);
 			}
diff --git a/src/backend/catalog/pg_enum.c b/src/backend/catalog/pg_enum.c
index 089a9a0..4bf90a4 100644
--- a/src/backend/catalog/pg_enum.c
+++ b/src/backend/catalog/pg_enum.c
@@ -126,7 +126,7 @@ EnumValuesCreate(Oid enumTypeOid, List *vals)
 		HeapTupleSetOid(tup, oids[elemno]);
 
 		simple_heap_insert(pg_enum, tup);
-		CatalogUpdateIndexes(pg_enum, tup);
+		CatalogUpdateIndexes(pg_enum, tup, false, NULL);
 		heap_freetuple(tup);
 
 		elemno++;
@@ -459,7 +459,7 @@ restart:
 	enum_tup = heap_form_tuple(RelationGetDescr(pg_enum), values, nulls);
 	HeapTupleSetOid(enum_tup, newOid);
 	simple_heap_insert(pg_enum, enum_tup);
-	CatalogUpdateIndexes(pg_enum, enum_tup);
+	CatalogUpdateIndexes(pg_enum, enum_tup, false, NULL);
 	heap_freetuple(enum_tup);
 
 	heap_close(pg_enum, RowExclusiveLock);
@@ -483,6 +483,8 @@ RenameEnumLabel(Oid enumTypeOid,
 	HeapTuple	old_tup;
 	bool		found_new;
 	int			i;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	/* check length of new label is ok */
 	if (strlen(newVal) > (NAMEDATALEN - 1))
@@ -543,8 +545,9 @@ RenameEnumLabel(Oid enumTypeOid,
 
 	/* Update the pg_enum entry */
 	namestrcpy(&en->enumlabel, newVal);
-	simple_heap_update(pg_enum, &enum_tup->t_self, enum_tup);
-	CatalogUpdateIndexes(pg_enum, enum_tup);
+	simple_heap_update(pg_enum, &enum_tup->t_self, enum_tup, &warm_update,
+			&modified_attrs);
+	CatalogUpdateIndexes(pg_enum, enum_tup, warm_update, modified_attrs);
 	heap_freetuple(enum_tup);
 
 	heap_close(pg_enum, RowExclusiveLock);
@@ -588,6 +591,8 @@ RenumberEnumType(Relation pg_enum, HeapTuple *existing, int nelems)
 		HeapTuple	newtup;
 		Form_pg_enum en;
 		float4		newsortorder;
+		bool		warm_update;
+		Bitmapset	*modified_attrs;
 
 		newtup = heap_copytuple(existing[i]);
 		en = (Form_pg_enum) GETSTRUCT(newtup);
@@ -597,9 +602,10 @@ RenumberEnumType(Relation pg_enum, HeapTuple *existing, int nelems)
 		{
 			en->enumsortorder = newsortorder;
 
-			simple_heap_update(pg_enum, &newtup->t_self, newtup);
+			simple_heap_update(pg_enum, &newtup->t_self, newtup, &warm_update,
+					&modified_attrs);
 
-			CatalogUpdateIndexes(pg_enum, newtup);
+			CatalogUpdateIndexes(pg_enum, newtup, warm_update, modified_attrs);
 		}
 
 		heap_freetuple(newtup);
diff --git a/src/backend/catalog/pg_largeobject.c b/src/backend/catalog/pg_largeobject.c
index 24edf6a..7ece246 100644
--- a/src/backend/catalog/pg_largeobject.c
+++ b/src/backend/catalog/pg_largeobject.c
@@ -66,7 +66,7 @@ LargeObjectCreate(Oid loid)
 	loid_new = simple_heap_insert(pg_lo_meta, ntup);
 	Assert(!OidIsValid(loid) || loid == loid_new);
 
-	CatalogUpdateIndexes(pg_lo_meta, ntup);
+	CatalogUpdateIndexes(pg_lo_meta, ntup, false, NULL);
 
 	heap_freetuple(ntup);
 
diff --git a/src/backend/catalog/pg_namespace.c b/src/backend/catalog/pg_namespace.c
index f048ad4..6b31e7e 100644
--- a/src/backend/catalog/pg_namespace.c
+++ b/src/backend/catalog/pg_namespace.c
@@ -79,7 +79,7 @@ NamespaceCreate(const char *nspName, Oid ownerId, bool isTemp)
 	nspoid = simple_heap_insert(nspdesc, tup);
 	Assert(OidIsValid(nspoid));
 
-	CatalogUpdateIndexes(nspdesc, tup);
+	CatalogUpdateIndexes(nspdesc, tup, false, NULL);
 
 	heap_close(nspdesc, RowExclusiveLock);
 
diff --git a/src/backend/catalog/pg_operator.c b/src/backend/catalog/pg_operator.c
index 556f9fe..77bbd97 100644
--- a/src/backend/catalog/pg_operator.c
+++ b/src/backend/catalog/pg_operator.c
@@ -264,7 +264,7 @@ OperatorShellMake(const char *operatorName,
 	 */
 	operatorObjectId = simple_heap_insert(pg_operator_desc, tup);
 
-	CatalogUpdateIndexes(pg_operator_desc, tup);
+	CatalogUpdateIndexes(pg_operator_desc, tup, false, NULL);
 
 	/* Add dependencies for the entry */
 	makeOperatorDependencies(tup, false);
@@ -350,6 +350,8 @@ OperatorCreate(const char *operatorName,
 	NameData	oname;
 	int			i;
 	ObjectAddress address;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	/*
 	 * Sanity checks
@@ -526,7 +528,8 @@ OperatorCreate(const char *operatorName,
 								nulls,
 								replaces);
 
-		simple_heap_update(pg_operator_desc, &tup->t_self, tup);
+		simple_heap_update(pg_operator_desc, &tup->t_self, tup, &warm_update,
+				&modified_attrs);
 	}
 	else
 	{
@@ -536,10 +539,12 @@ OperatorCreate(const char *operatorName,
 							  values, nulls);
 
 		operatorObjectId = simple_heap_insert(pg_operator_desc, tup);
+		warm_update = false;
+		modified_attrs = NULL;
 	}
 
 	/* Must update the indexes in either case */
-	CatalogUpdateIndexes(pg_operator_desc, tup);
+	CatalogUpdateIndexes(pg_operator_desc, tup, warm_update, modified_attrs);
 
 	/* Add dependencies for the entry */
 	address = makeOperatorDependencies(tup, isUpdate);
@@ -695,8 +700,12 @@ OperatorUpd(Oid baseId, Oid commId, Oid negId, bool isDelete)
 		/* If any columns were found to need modification, update tuple. */
 		if (update_commutator)
 		{
-			simple_heap_update(pg_operator_desc, &tup->t_self, tup);
-			CatalogUpdateIndexes(pg_operator_desc, tup);
+			bool		warm_update;
+			Bitmapset	*modified_attrs;
+			simple_heap_update(pg_operator_desc, &tup->t_self, tup,
+					&warm_update, &modified_attrs);
+			CatalogUpdateIndexes(pg_operator_desc, tup, warm_update,
+					modified_attrs);
 
 			/*
 			 * Do CCI to make the updated tuple visible.  We must do this in
@@ -741,8 +750,13 @@ OperatorUpd(Oid baseId, Oid commId, Oid negId, bool isDelete)
 		/* If any columns were found to need modification, update tuple. */
 		if (update_negator)
 		{
-			simple_heap_update(pg_operator_desc, &tup->t_self, tup);
-			CatalogUpdateIndexes(pg_operator_desc, tup);
+			bool		warm_update;
+			Bitmapset	*modified_attrs;
+
+			simple_heap_update(pg_operator_desc, &tup->t_self, tup,
+					&warm_update, &modified_attrs);
+			CatalogUpdateIndexes(pg_operator_desc, tup, warm_update,
+					modified_attrs);
 
 			/*
 			 * In the deletion case, do CCI to make the updated tuple visible.
diff --git a/src/backend/catalog/pg_proc.c b/src/backend/catalog/pg_proc.c
index 7ae192a..0f7027a 100644
--- a/src/backend/catalog/pg_proc.c
+++ b/src/backend/catalog/pg_proc.c
@@ -118,6 +118,8 @@ ProcedureCreate(const char *procedureName,
 				referenced;
 	int			i;
 	Oid			trfid;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	/*
 	 * sanity checks
@@ -573,7 +575,8 @@ ProcedureCreate(const char *procedureName,
 
 		/* Okay, do it... */
 		tup = heap_modify_tuple(oldtup, tupDesc, values, nulls, replaces);
-		simple_heap_update(rel, &tup->t_self, tup);
+		simple_heap_update(rel, &tup->t_self, tup, &warm_update,
+				&modified_attrs);
 
 		ReleaseSysCache(oldtup);
 		is_update = true;
@@ -593,10 +596,12 @@ ProcedureCreate(const char *procedureName,
 		tup = heap_form_tuple(tupDesc, values, nulls);
 		simple_heap_insert(rel, tup);
 		is_update = false;
+		warm_update = false;
+		modified_attrs = NULL;
 	}
 
 	/* Need to update indexes for either the insert or update case */
-	CatalogUpdateIndexes(rel, tup);
+	CatalogUpdateIndexes(rel, tup, warm_update, modified_attrs);
 
 	retval = HeapTupleGetOid(tup);
 
diff --git a/src/backend/catalog/pg_publication.c b/src/backend/catalog/pg_publication.c
index 576b7fa..b93f7c3 100644
--- a/src/backend/catalog/pg_publication.c
+++ b/src/backend/catalog/pg_publication.c
@@ -149,7 +149,7 @@ publication_add_relation(Oid pubid, Relation targetrel,
 
 	/* Insert tuple into catalog. */
 	prrelid = simple_heap_insert(rel, tup);
-	CatalogUpdateIndexes(rel, tup);
+	CatalogUpdateIndexes(rel, tup, false, NULL);
 	heap_freetuple(tup);
 
 	ObjectAddressSet(myself, PublicationRelRelationId, prrelid);
diff --git a/src/backend/catalog/pg_range.c b/src/backend/catalog/pg_range.c
index d3a4c26..7d4cc5d 100644
--- a/src/backend/catalog/pg_range.c
+++ b/src/backend/catalog/pg_range.c
@@ -59,7 +59,7 @@ RangeCreate(Oid rangeTypeOid, Oid rangeSubType, Oid rangeCollation,
 	tup = heap_form_tuple(RelationGetDescr(pg_range), values, nulls);
 
 	simple_heap_insert(pg_range, tup);
-	CatalogUpdateIndexes(pg_range, tup);
+	CatalogUpdateIndexes(pg_range, tup, false, NULL);
 	heap_freetuple(tup);
 
 	/* record type's dependencies on range-related items */
diff --git a/src/backend/catalog/pg_shdepend.c b/src/backend/catalog/pg_shdepend.c
index 60ed957..3019b4e 100644
--- a/src/backend/catalog/pg_shdepend.c
+++ b/src/backend/catalog/pg_shdepend.c
@@ -253,6 +253,8 @@ shdepChangeDep(Relation sdepRel,
 	}
 	else if (oldtup)
 	{
+		bool		warm_update;
+		Bitmapset	*modified_attrs;
 		/* Need to update existing entry */
 		Form_pg_shdepend shForm = (Form_pg_shdepend) GETSTRUCT(oldtup);
 
@@ -260,10 +262,11 @@ shdepChangeDep(Relation sdepRel,
 		shForm->refclassid = refclassid;
 		shForm->refobjid = refobjid;
 
-		simple_heap_update(sdepRel, &oldtup->t_self, oldtup);
+		simple_heap_update(sdepRel, &oldtup->t_self, oldtup, &warm_update,
+				&modified_attrs);
 
 		/* keep indexes current */
-		CatalogUpdateIndexes(sdepRel, oldtup);
+		CatalogUpdateIndexes(sdepRel, oldtup, warm_update, modified_attrs);
 	}
 	else
 	{
@@ -290,7 +293,7 @@ shdepChangeDep(Relation sdepRel,
 		simple_heap_insert(sdepRel, oldtup);
 
 		/* keep indexes current */
-		CatalogUpdateIndexes(sdepRel, oldtup);
+		CatalogUpdateIndexes(sdepRel, oldtup, false, NULL);
 	}
 
 	if (oldtup)
@@ -762,7 +765,7 @@ copyTemplateDependencies(Oid templateDbId, Oid newDbId)
 		simple_heap_insert(sdepRel, newtup);
 
 		/* Keep indexes current */
-		CatalogIndexInsert(indstate, newtup);
+		CatalogIndexInsert(indstate, newtup, false, NULL);
 
 		heap_freetuple(newtup);
 	}
@@ -885,7 +888,7 @@ shdepAddDependency(Relation sdepRel,
 	simple_heap_insert(sdepRel, tup);
 
 	/* keep indexes current */
-	CatalogUpdateIndexes(sdepRel, tup);
+	CatalogUpdateIndexes(sdepRel, tup, false, NULL);
 
 	/* clean up */
 	heap_freetuple(tup);
diff --git a/src/backend/catalog/pg_type.c b/src/backend/catalog/pg_type.c
index 6d9a324..5857045 100644
--- a/src/backend/catalog/pg_type.c
+++ b/src/backend/catalog/pg_type.c
@@ -144,7 +144,7 @@ TypeShellMake(const char *typeName, Oid typeNamespace, Oid ownerId)
 	 */
 	typoid = simple_heap_insert(pg_type_desc, tup);
 
-	CatalogUpdateIndexes(pg_type_desc, tup);
+	CatalogUpdateIndexes(pg_type_desc, tup, false, NULL);
 
 	/*
 	 * Create dependencies.  We can/must skip this in bootstrap mode.
@@ -237,6 +237,8 @@ TypeCreate(Oid newTypeOid,
 	int			i;
 	Acl		   *typacl = NULL;
 	ObjectAddress address;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	/*
 	 * We assume that the caller validated the arguments individually, but did
@@ -430,7 +432,8 @@ TypeCreate(Oid newTypeOid,
 								nulls,
 								replaces);
 
-		simple_heap_update(pg_type_desc, &tup->t_self, tup);
+		simple_heap_update(pg_type_desc, &tup->t_self, tup, &warm_update,
+				&modified_attrs);
 
 		typeObjectId = HeapTupleGetOid(tup);
 
@@ -459,10 +462,12 @@ TypeCreate(Oid newTypeOid,
 		/* else allow system to assign oid */
 
 		typeObjectId = simple_heap_insert(pg_type_desc, tup);
+		warm_update = false;
+		modified_attrs = NULL;
 	}
 
 	/* Update indexes */
-	CatalogUpdateIndexes(pg_type_desc, tup);
+	CatalogUpdateIndexes(pg_type_desc, tup, warm_update, modified_attrs);
 
 	/*
 	 * Create dependencies.  We can/must skip this in bootstrap mode.
@@ -700,6 +705,8 @@ RenameTypeInternal(Oid typeOid, const char *newTypeName, Oid typeNamespace)
 	HeapTuple	tuple;
 	Form_pg_type typ;
 	Oid			arrayOid;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	pg_type_desc = heap_open(TypeRelationId, RowExclusiveLock);
 
@@ -724,10 +731,11 @@ RenameTypeInternal(Oid typeOid, const char *newTypeName, Oid typeNamespace)
 	/* OK, do the rename --- tuple is a copy, so OK to scribble on it */
 	namestrcpy(&(typ->typname), newTypeName);
 
-	simple_heap_update(pg_type_desc, &tuple->t_self, tuple);
+	simple_heap_update(pg_type_desc, &tuple->t_self, tuple, &warm_update,
+			&modified_attrs);
 
 	/* update the system catalog indexes */
-	CatalogUpdateIndexes(pg_type_desc, tuple);
+	CatalogUpdateIndexes(pg_type_desc, tuple, warm_update, modified_attrs);
 
 	InvokeObjectPostAlterHook(TypeRelationId, typeOid, 0);
 
diff --git a/src/backend/catalog/system_views.sql b/src/backend/catalog/system_views.sql
index 4dfedf8..27bc137 100644
--- a/src/backend/catalog/system_views.sql
+++ b/src/backend/catalog/system_views.sql
@@ -487,6 +487,7 @@ CREATE VIEW pg_stat_all_tables AS
             pg_stat_get_tuples_updated(C.oid) AS n_tup_upd,
             pg_stat_get_tuples_deleted(C.oid) AS n_tup_del,
             pg_stat_get_tuples_hot_updated(C.oid) AS n_tup_hot_upd,
+            pg_stat_get_tuples_warm_updated(C.oid) AS n_tup_warm_upd,
             pg_stat_get_live_tuples(C.oid) AS n_live_tup,
             pg_stat_get_dead_tuples(C.oid) AS n_dead_tup,
             pg_stat_get_mod_since_analyze(C.oid) AS n_mod_since_analyze,
@@ -517,7 +518,8 @@ CREATE VIEW pg_stat_xact_all_tables AS
             pg_stat_get_xact_tuples_inserted(C.oid) AS n_tup_ins,
             pg_stat_get_xact_tuples_updated(C.oid) AS n_tup_upd,
             pg_stat_get_xact_tuples_deleted(C.oid) AS n_tup_del,
-            pg_stat_get_xact_tuples_hot_updated(C.oid) AS n_tup_hot_upd
+            pg_stat_get_xact_tuples_hot_updated(C.oid) AS n_tup_hot_upd,
+            pg_stat_get_xact_tuples_warm_updated(C.oid) AS n_tup_warm_upd
     FROM pg_class C LEFT JOIN
          pg_index I ON C.oid = I.indrelid
          LEFT JOIN pg_namespace N ON (N.oid = C.relnamespace)
diff --git a/src/backend/catalog/toasting.c b/src/backend/catalog/toasting.c
index ee4a182..b48f785 100644
--- a/src/backend/catalog/toasting.c
+++ b/src/backend/catalog/toasting.c
@@ -349,11 +349,15 @@ create_toast_table(Relation rel, Oid toastOid, Oid toastIndexOid,
 
 	if (!IsBootstrapProcessingMode())
 	{
+		bool		warm_update;
+		Bitmapset	*modified_attrs;
+
 		/* normal case, use a transactional update */
-		simple_heap_update(class_rel, &reltup->t_self, reltup);
+		simple_heap_update(class_rel, &reltup->t_self, reltup, &warm_update,
+				&modified_attrs);
 
 		/* Keep catalog indexes current */
-		CatalogUpdateIndexes(class_rel, reltup);
+		CatalogUpdateIndexes(class_rel, reltup, warm_update, modified_attrs);
 	}
 	else
 	{
diff --git a/src/backend/commands/alter.c b/src/backend/commands/alter.c
index 768fcc8..5c03207 100644
--- a/src/backend/commands/alter.c
+++ b/src/backend/commands/alter.c
@@ -172,6 +172,8 @@ AlterObjectRename_internal(Relation rel, Oid objectId, const char *new_name)
 	bool	   *nulls;
 	bool	   *replaces;
 	NameData	nameattrdata;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	oldtup = SearchSysCache1(oidCacheId, ObjectIdGetDatum(objectId));
 	if (!HeapTupleIsValid(oldtup))
@@ -284,8 +286,9 @@ AlterObjectRename_internal(Relation rel, Oid objectId, const char *new_name)
 							   values, nulls, replaces);
 
 	/* Perform actual update */
-	simple_heap_update(rel, &oldtup->t_self, newtup);
-	CatalogUpdateIndexes(rel, newtup);
+	simple_heap_update(rel, &oldtup->t_self, newtup, &warm_update,
+			&modified_attrs);
+	CatalogUpdateIndexes(rel, newtup, warm_update, modified_attrs);
 
 	InvokeObjectPostAlterHook(classId, objectId, 0);
 
@@ -617,6 +620,8 @@ AlterObjectNamespace_internal(Relation rel, Oid objid, Oid nspOid)
 	Datum	   *values;
 	bool	   *nulls;
 	bool	   *replaces;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	tup = SearchSysCacheCopy1(oidCacheId, ObjectIdGetDatum(objid));
 	if (!HeapTupleIsValid(tup)) /* should not happen */
@@ -722,8 +727,8 @@ AlterObjectNamespace_internal(Relation rel, Oid objid, Oid nspOid)
 							   values, nulls, replaces);
 
 	/* Perform actual update */
-	simple_heap_update(rel, &tup->t_self, newtup);
-	CatalogUpdateIndexes(rel, newtup);
+	simple_heap_update(rel, &tup->t_self, newtup, &warm_update, &modified_attrs);
+	CatalogUpdateIndexes(rel, newtup, warm_update, modified_attrs);
 
 	/* Release memory */
 	pfree(values);
@@ -880,6 +885,8 @@ AlterObjectOwner_internal(Relation rel, Oid objectId, Oid new_ownerId)
 		Datum	   *values;
 		bool	   *nulls;
 		bool	   *replaces;
+		bool		warm_update;
+		Bitmapset	*modified_attrs;
 
 		/* Superusers can bypass permission checks */
 		if (!superuser())
@@ -954,8 +961,9 @@ AlterObjectOwner_internal(Relation rel, Oid objectId, Oid new_ownerId)
 								   values, nulls, replaces);
 
 		/* Perform actual update */
-		simple_heap_update(rel, &newtup->t_self, newtup);
-		CatalogUpdateIndexes(rel, newtup);
+		simple_heap_update(rel, &newtup->t_self, newtup, &warm_update,
+				&modified_attrs);
+		CatalogUpdateIndexes(rel, newtup, warm_update, modified_attrs);
 
 		/* Update owner dependency reference */
 		if (classId == LargeObjectMetadataRelationId)
diff --git a/src/backend/commands/amcmds.c b/src/backend/commands/amcmds.c
index 29061b8..2f33b2c 100644
--- a/src/backend/commands/amcmds.c
+++ b/src/backend/commands/amcmds.c
@@ -88,7 +88,7 @@ CreateAccessMethod(CreateAmStmt *stmt)
 	tup = heap_form_tuple(RelationGetDescr(rel), values, nulls);
 
 	amoid = simple_heap_insert(rel, tup);
-	CatalogUpdateIndexes(rel, tup);
+	CatalogUpdateIndexes(rel, tup, false, NULL);
 	heap_freetuple(tup);
 
 	myself.classId = AccessMethodRelationId;
diff --git a/src/backend/commands/analyze.c b/src/backend/commands/analyze.c
index e3e1a53..b9a9ede 100644
--- a/src/backend/commands/analyze.c
+++ b/src/backend/commands/analyze.c
@@ -1498,6 +1498,8 @@ update_attstats(Oid relid, bool inh, int natts, VacAttrStats **vacattrstats)
 		Datum		values[Natts_pg_statistic];
 		bool		nulls[Natts_pg_statistic];
 		bool		replaces[Natts_pg_statistic];
+		bool		warm_update;
+		Bitmapset	*modified_attrs;
 
 		/* Ignore attr if we weren't able to collect stats */
 		if (!stats->stats_valid)
@@ -1589,17 +1591,20 @@ update_attstats(Oid relid, bool inh, int natts, VacAttrStats **vacattrstats)
 									 nulls,
 									 replaces);
 			ReleaseSysCache(oldtup);
-			simple_heap_update(sd, &stup->t_self, stup);
+			simple_heap_update(sd, &stup->t_self, stup, &warm_update,
+					&modified_attrs);
 		}
 		else
 		{
 			/* No, insert new tuple */
 			stup = heap_form_tuple(RelationGetDescr(sd), values, nulls);
 			simple_heap_insert(sd, stup);
+			warm_update = false;
+			modified_attrs = NULL;
 		}
 
 		/* update indexes too */
-		CatalogUpdateIndexes(sd, stup);
+		CatalogUpdateIndexes(sd, stup, warm_update, modified_attrs);
 
 		heap_freetuple(stup);
 	}
diff --git a/src/backend/commands/cluster.c b/src/backend/commands/cluster.c
index f9309fc..03ed871 100644
--- a/src/backend/commands/cluster.c
+++ b/src/backend/commands/cluster.c
@@ -522,18 +522,28 @@ mark_index_clustered(Relation rel, Oid indexOid, bool is_internal)
 		 */
 		if (indexForm->indisclustered)
 		{
+			bool		warm_update;
+			Bitmapset	*modified_attrs;
+
 			indexForm->indisclustered = false;
-			simple_heap_update(pg_index, &indexTuple->t_self, indexTuple);
-			CatalogUpdateIndexes(pg_index, indexTuple);
+			simple_heap_update(pg_index, &indexTuple->t_self, indexTuple,
+					&warm_update, &modified_attrs);
+			CatalogUpdateIndexes(pg_index, indexTuple, warm_update,
+					modified_attrs);
 		}
 		else if (thisIndexOid == indexOid)
 		{
+			bool		warm_update;
+			Bitmapset	*modified_attrs;
+
 			/* this was checked earlier, but let's be real sure */
 			if (!IndexIsValid(indexForm))
 				elog(ERROR, "cannot cluster on invalid index %u", indexOid);
 			indexForm->indisclustered = true;
-			simple_heap_update(pg_index, &indexTuple->t_self, indexTuple);
-			CatalogUpdateIndexes(pg_index, indexTuple);
+			simple_heap_update(pg_index, &indexTuple->t_self, indexTuple,
+					&warm_update, &modified_attrs);
+			CatalogUpdateIndexes(pg_index, indexTuple, warm_update,
+					modified_attrs);
 		}
 
 		InvokeObjectPostAlterHookArg(IndexRelationId, thisIndexOid, 0,
@@ -1287,13 +1297,18 @@ swap_relation_files(Oid r1, Oid r2, bool target_is_pg_class,
 	 */
 	if (!target_is_pg_class)
 	{
-		simple_heap_update(relRelation, &reltup1->t_self, reltup1);
-		simple_heap_update(relRelation, &reltup2->t_self, reltup2);
+		bool warm_update1 = false, warm_update2 = false;
+		Bitmapset *modified_attrs1, *modified_attrs2;
+
+		simple_heap_update(relRelation, &reltup1->t_self, reltup1,
+				&warm_update1, &modified_attrs1);
+		simple_heap_update(relRelation, &reltup2->t_self, reltup2,
+				&warm_update2, &modified_attrs2);
 
 		/* Keep system catalogs current */
 		indstate = CatalogOpenIndexes(relRelation);
-		CatalogIndexInsert(indstate, reltup1);
-		CatalogIndexInsert(indstate, reltup2);
+		CatalogIndexInsert(indstate, reltup1, warm_update1, modified_attrs1);
+		CatalogIndexInsert(indstate, reltup2, warm_update2, modified_attrs2);
 		CatalogCloseIndexes(indstate);
 	}
 	else
@@ -1547,6 +1562,8 @@ finish_heap_swap(Oid OIDOldHeap, Oid OIDNewHeap,
 		Relation	relRelation;
 		HeapTuple	reltup;
 		Form_pg_class relform;
+		bool		warm_update;
+		Bitmapset	*modified_attrs;
 
 		relRelation = heap_open(RelationRelationId, RowExclusiveLock);
 
@@ -1558,8 +1575,9 @@ finish_heap_swap(Oid OIDOldHeap, Oid OIDNewHeap,
 		relform->relfrozenxid = frozenXid;
 		relform->relminmxid = cutoffMulti;
 
-		simple_heap_update(relRelation, &reltup->t_self, reltup);
-		CatalogUpdateIndexes(relRelation, reltup);
+		simple_heap_update(relRelation, &reltup->t_self, reltup, &warm_update,
+				&modified_attrs);
+		CatalogUpdateIndexes(relRelation, reltup, warm_update, modified_attrs);
 
 		heap_close(relRelation, RowExclusiveLock);
 	}
diff --git a/src/backend/commands/comment.c b/src/backend/commands/comment.c
index ada0b03..60b3631 100644
--- a/src/backend/commands/comment.c
+++ b/src/backend/commands/comment.c
@@ -150,6 +150,8 @@ CreateComments(Oid oid, Oid classoid, int32 subid, char *comment)
 	bool		nulls[Natts_pg_description];
 	bool		replaces[Natts_pg_description];
 	int			i;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	/* Reduce empty-string to NULL case */
 	if (comment != NULL && strlen(comment) == 0)
@@ -199,7 +201,8 @@ CreateComments(Oid oid, Oid classoid, int32 subid, char *comment)
 		{
 			newtuple = heap_modify_tuple(oldtuple, RelationGetDescr(description), values,
 										 nulls, replaces);
-			simple_heap_update(description, &oldtuple->t_self, newtuple);
+			simple_heap_update(description, &oldtuple->t_self, newtuple,
+					&warm_update, &modified_attrs);
 		}
 
 		break;					/* Assume there can be only one match */
@@ -214,12 +217,13 @@ CreateComments(Oid oid, Oid classoid, int32 subid, char *comment)
 		newtuple = heap_form_tuple(RelationGetDescr(description),
 								   values, nulls);
 		simple_heap_insert(description, newtuple);
+		warm_update = false;
 	}
 
 	/* Update indexes, if necessary */
 	if (newtuple != NULL)
 	{
-		CatalogUpdateIndexes(description, newtuple);
+		CatalogUpdateIndexes(description, newtuple, warm_update, modified_attrs);
 		heap_freetuple(newtuple);
 	}
 
@@ -249,6 +253,8 @@ CreateSharedComments(Oid oid, Oid classoid, char *comment)
 	bool		nulls[Natts_pg_shdescription];
 	bool		replaces[Natts_pg_shdescription];
 	int			i;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	/* Reduce empty-string to NULL case */
 	if (comment != NULL && strlen(comment) == 0)
@@ -293,7 +299,8 @@ CreateSharedComments(Oid oid, Oid classoid, char *comment)
 		{
 			newtuple = heap_modify_tuple(oldtuple, RelationGetDescr(shdescription),
 										 values, nulls, replaces);
-			simple_heap_update(shdescription, &oldtuple->t_self, newtuple);
+			simple_heap_update(shdescription, &oldtuple->t_self, newtuple,
+					&warm_update, &modified_attrs);
 		}
 
 		break;					/* Assume there can be only one match */
@@ -308,12 +315,14 @@ CreateSharedComments(Oid oid, Oid classoid, char *comment)
 		newtuple = heap_form_tuple(RelationGetDescr(shdescription),
 								   values, nulls);
 		simple_heap_insert(shdescription, newtuple);
+		warm_update = false;
 	}
 
 	/* Update indexes, if necessary */
 	if (newtuple != NULL)
 	{
-		CatalogUpdateIndexes(shdescription, newtuple);
+		CatalogUpdateIndexes(shdescription, newtuple, warm_update,
+				modified_attrs);
 		heap_freetuple(newtuple);
 	}
 
diff --git a/src/backend/commands/constraint.c b/src/backend/commands/constraint.c
index 77cf8ce..faef5b4 100644
--- a/src/backend/commands/constraint.c
+++ b/src/backend/commands/constraint.c
@@ -40,6 +40,7 @@ unique_key_recheck(PG_FUNCTION_ARGS)
 	TriggerData *trigdata = (TriggerData *) fcinfo->context;
 	const char *funcname = "unique_key_recheck";
 	HeapTuple	new_row;
+	HeapTupleData heapTuple;
 	ItemPointerData tmptid;
 	Relation	indexRel;
 	IndexInfo  *indexInfo;
@@ -102,7 +103,8 @@ unique_key_recheck(PG_FUNCTION_ARGS)
 	 * removed.
 	 */
 	tmptid = new_row->t_self;
-	if (!heap_hot_search(&tmptid, trigdata->tg_relation, SnapshotSelf, NULL))
+	if (!heap_hot_search(&tmptid, trigdata->tg_relation, SnapshotSelf, NULL,
+				NULL, NULL, &heapTuple))
 	{
 		/*
 		 * All rows in the HOT chain are dead, so skip the check.
